// Flappy Bird Simulator for ESPresso Lite

#ifndef _GAME_FLAPPY_BIRD_H_
#define _GAME_FLAPPY_BIRD_H_

#include "Game.h"

namespace flappyBird {
const uint8_t backgroundBitmap[(128 * 64) / 8] PROGMEM = {
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF
};

static const int numberOfFrames = 3;
static const int numberOfDegrees = 5;
const uint8_t birdBitmap[numberOfFrames][numberOfDegrees][(16 * 16) / 8] PROGMEM = {
  {
    {0x00, 0x00, 0x00, 0x0F, 0xE0, 0x10, 0x90, 0x20, 0x88, 0xE8, 0x0C, 0xB1, 0x74, 0x5E, 0x8C, 0xA4, 0x82, 0x94, 0x82, 0x48, 0x81, 0x30, 0x41, 0x10, 0x3E, 0x08, 0x20, 0x06, 0xC0, 0x01, 0x00, 0x00}, // bird00.png
    {0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0x30, 0x12, 0x08, 0x21, 0x1E, 0x51, 0x21, 0x51, 0x41, 0x42, 0x41, 0xFC, 0x22, 0x82, 0x1C, 0xFD, 0x04, 0x42, 0x18, 0x3C, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00}, // bird01.png
    {0x00, 0x00, 0x00, 0x00, 0xFC, 0x03, 0x42, 0x04, 0x42, 0x18, 0x82, 0x24, 0x82, 0x42, 0x86, 0x42, 0x7A, 0x52, 0x02, 0x45, 0x04, 0x49, 0x88, 0x32, 0x90, 0x24, 0xE0, 0x29, 0x00, 0x1E, 0x00, 0x00}, // bird02.png
    {0x30, 0x00, 0xC8, 0x00, 0x08, 0x07, 0x08, 0x0D, 0x08, 0x12, 0x0C, 0x22, 0x12, 0x22, 0xE2, 0x39, 0x02, 0x44, 0x04, 0x42, 0x84, 0x43, 0x48, 0x4A, 0xB0, 0x26, 0x20, 0x1D, 0x40, 0x0A, 0x80, 0x0D}, // bird03.png
    {0x80, 0x03, 0x40, 0x04, 0x30, 0x04, 0x28, 0x0C, 0x28, 0x14, 0x44, 0x12, 0x84, 0x21, 0x04, 0x20, 0x24, 0x2E, 0x54, 0x31, 0xA8, 0x20, 0xA8, 0x20, 0xA8, 0x16, 0xA8, 0x08, 0xB0, 0x07, 0xE0, 0x00}  // bird04.png
  },
  {
    {0x00, 0x00, 0x00, 0x0F, 0xE0, 0x10, 0x90, 0x20, 0x88, 0xE8, 0x04, 0xB1, 0xE4, 0x5E, 0x92, 0xA4, 0x8A, 0x94, 0x86, 0x48, 0x42, 0x30, 0x42, 0x10, 0x24, 0x08, 0x38, 0x06, 0xC0, 0x01, 0x00, 0x00}, // bird10.png
    {0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0x30, 0x12, 0x08, 0x21, 0x04, 0x51, 0x02, 0x51, 0x3E, 0x42, 0x41, 0xFC, 0x41, 0x82, 0x3E, 0xFD, 0x04, 0x42, 0x18, 0x3C, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00}, // bird11.png
    {0x00, 0x00, 0x00, 0x00, 0xEC, 0x03, 0x12, 0x04, 0x22, 0x18, 0x42, 0x24, 0x86, 0x42, 0x8A, 0x42, 0x72, 0x52, 0x02, 0x45, 0x04, 0x49, 0x88, 0x32, 0x90, 0x24, 0xE0, 0x29, 0x00, 0x1E, 0x00, 0x00}, // bird12.png
    {0x00, 0x00, 0xF0, 0x01, 0x48, 0x06, 0x84, 0x08, 0x04, 0x11, 0x0C, 0x22, 0x32, 0x22, 0xC2, 0x3B, 0x02, 0x44, 0x04, 0x42, 0x84, 0x43, 0x48, 0x4A, 0xB0, 0x26, 0x20, 0x1D, 0x40, 0x0A, 0x80, 0x0D}, // bird13.png
    {0xC0, 0x00, 0x20, 0x03, 0x30, 0x05, 0x28, 0x09, 0x28, 0x11, 0x24, 0x11, 0xC4, 0x20, 0x04, 0x20, 0x24, 0x2E, 0x54, 0x31, 0xA8, 0x20, 0xA8, 0x20, 0xA8, 0x16, 0xA8, 0x08, 0xB0, 0x07, 0xE0, 0x00}  // bird14.png
  },
  {
    {0x00, 0x00, 0x00, 0x0F, 0xE0, 0x10, 0x90, 0x20, 0x88, 0xE8, 0x04, 0xB1, 0xC4, 0x5E, 0xA2, 0xA4, 0x12, 0x95, 0x0A, 0x49, 0x06, 0x31, 0x02, 0x11, 0xC4, 0x08, 0x38, 0x06, 0xC0, 0x01, 0x00, 0x00}, // bird20.png
    {0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0x30, 0x12, 0x08, 0x21, 0x04, 0x51, 0x02, 0x51, 0x02, 0x42, 0x3E, 0xFC, 0x41, 0x82, 0x21, 0xFD, 0x11, 0x42, 0x1E, 0x3C, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00}, // bird21.png
    {0x00, 0x00, 0x00, 0x00, 0xE0, 0x03, 0x18, 0x04, 0x14, 0x18, 0x22, 0x24, 0x42, 0x42, 0x82, 0x42, 0x82, 0x52, 0x42, 0x45, 0x3C, 0x49, 0x88, 0x32, 0x90, 0x24, 0xE0, 0x29, 0x00, 0x1E, 0x00, 0x00}, // bird22.png
    {0x00, 0x00, 0xF0, 0x01, 0x28, 0x06, 0x44, 0x08, 0x84, 0x10, 0x04, 0x21, 0x0A, 0x22, 0x0A, 0x3B, 0xF2, 0x44, 0x04, 0x42, 0x84, 0x43, 0x48, 0x4A, 0xB0, 0x26, 0x20, 0x1D, 0x40, 0x0A, 0x80, 0x0D}, // bird23.png
    {0x70, 0x00, 0x88, 0x03, 0x88, 0x04, 0x88, 0x08, 0x98, 0x10, 0xA4, 0x10, 0x44, 0x20, 0x04, 0x20, 0x24, 0x2E, 0x54, 0x31, 0xA8, 0x20, 0xA8, 0x20, 0xA8, 0x16, 0xA8, 0x08, 0xB0, 0x07, 0xE0, 0x00}  // bird24.png
  }
};

const uint8_t birdMaskBitmap[numberOfFrames][numberOfDegrees][(16 * 16) / 8] PROGMEM = {
  {
    {0x00, 0x00, 0x00, 0x0F, 0xE0, 0x1F, 0xF0, 0x3F, 0xF8, 0xFF, 0xFC, 0xFF, 0xFC, 0xFF, 0xFC, 0xFF, 0xFE, 0xFF, 0xFE, 0x7F, 0xFF, 0x3F, 0xFF, 0x1F, 0xFE, 0x0F, 0xE0, 0x07, 0xC0, 0x01, 0x00, 0x00}, // birdMask00.png
    {0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0xF0, 0x1F, 0xF8, 0x3F, 0xFE, 0x7F, 0xFF, 0x7F, 0xFF, 0x7F, 0xFF, 0xFF, 0xFE, 0xFF, 0xFC, 0xFF, 0xFC, 0x7F, 0xF8, 0x3F, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00}, // birdMask01.png
    {0x00, 0x00, 0x00, 0x00, 0xFC, 0x03, 0xFE, 0x07, 0xFE, 0x1F, 0xFE, 0x3F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFC, 0x7F, 0xF8, 0x3F, 0xF0, 0x3F, 0xE0, 0x3F, 0x00, 0x1E, 0x00, 0x00}, // birdMask02.png
    {0x30, 0x00, 0xF8, 0x00, 0xF8, 0x07, 0xF8, 0x0F, 0xF8, 0x1F, 0xFC, 0x3F, 0xFE, 0x3F, 0xFE, 0x3F, 0xFE, 0x7F, 0xFC, 0x7F, 0xFC, 0x7F, 0xF8, 0x7F, 0xF0, 0x3F, 0xE0, 0x1F, 0xC0, 0x0F, 0x80, 0x0F}, // birdMask03.png
    {0x80, 0x03, 0xC0, 0x07, 0xF0, 0x07, 0xF8, 0x0F, 0xF8, 0x1F, 0xFC, 0x1F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xF8, 0x3F, 0xF8, 0x3F, 0xF8, 0x1F, 0xF8, 0x0F, 0xF0, 0x07, 0xE0, 0x00}  // birdMask04.png
  },
  {
    {0x00, 0x00, 0x00, 0x0F, 0xE0, 0x1F, 0xF0, 0x3F, 0xF8, 0xFF, 0xFC, 0xFF, 0xFC, 0xFF, 0xFE, 0xFF, 0xFE, 0xFF, 0xFE, 0x7F, 0xFE, 0x3F, 0xFE, 0x1F, 0xFC, 0x0F, 0xF8, 0x07, 0xC0, 0x01, 0x00, 0x00}, // birdMask10.png
    {0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0xF0, 0x1F, 0xF8, 0x3F, 0xFC, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFF, 0xFC, 0x7F, 0xF8, 0x3F, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00}, // birdMask11.png
    {0x00, 0x00, 0x00, 0x00, 0xEC, 0x03, 0xFE, 0x07, 0xFE, 0x1F, 0xFE, 0x3F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFC, 0x7F, 0xF8, 0x3F, 0xF0, 0x3F, 0xE0, 0x3F, 0x00, 0x1E, 0x00, 0x00}, // birdMask12.png
    {0x00, 0x00, 0xF0, 0x01, 0xF8, 0x07, 0xFC, 0x0F, 0xFC, 0x1F, 0xFC, 0x3F, 0xFE, 0x3F, 0xFE, 0x3F, 0xFE, 0x7F, 0xFC, 0x7F, 0xFC, 0x7F, 0xF8, 0x7F, 0xF0, 0x3F, 0xE0, 0x1F, 0xC0, 0x0F, 0x80, 0x0F}, // birdMask13.png
    {0xC0, 0x00, 0xE0, 0x03, 0xF0, 0x07, 0xF8, 0x0F, 0xF8, 0x1F, 0xFC, 0x1F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xF8, 0x3F, 0xF8, 0x3F, 0xF8, 0x1F, 0xF8, 0x0F, 0xF0, 0x07, 0xE0, 0x00}  // birdMask14.png
  },
  {
    {0x00, 0x00, 0x00, 0x0F, 0xE0, 0x1F, 0xF0, 0x3F, 0xF8, 0xFF, 0xFC, 0xFF, 0xFC, 0xFF, 0xFE, 0xFF, 0xFE, 0xFF, 0xFE, 0x7F, 0xFE, 0x3F, 0xFE, 0x1F, 0xFC, 0x0F, 0xF8, 0x07, 0xC0, 0x01, 0x00, 0x00}, // birdMask20.png
    {0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0xF0, 0x1F, 0xF8, 0x3F, 0xFC, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0xFE, 0x3F, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00}, // birdMask21.png
    {0x00, 0x00, 0x00, 0x00, 0xE0, 0x03, 0xF8, 0x07, 0xFC, 0x1F, 0xFE, 0x3F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xFC, 0x7F, 0xF8, 0x3F, 0xF0, 0x3F, 0xE0, 0x3F, 0x00, 0x1E, 0x00, 0x00}, // birdMask22.png
    {0x00, 0x00, 0xF0, 0x01, 0xF8, 0x07, 0xFC, 0x0F, 0xFC, 0x1F, 0xFC, 0x3F, 0xFE, 0x3F, 0xFE, 0x3F, 0xFE, 0x7F, 0xFC, 0x7F, 0xFC, 0x7F, 0xF8, 0x7F, 0xF0, 0x3F, 0xE0, 0x1F, 0xC0, 0x0F, 0x80, 0x0F}, // birdMask23.png
    {0x70, 0x00, 0xF8, 0x03, 0xF8, 0x07, 0xF8, 0x0F, 0xF8, 0x1F, 0xFC, 0x1F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xFC, 0x3F, 0xF8, 0x3F, 0xF8, 0x3F, 0xF8, 0x1F, 0xF8, 0x0F, 0xF0, 0x07, 0xE0, 0x00}  // birdMask24.png
  }
};

const uint8_t gameOverBitmap[(64 * 16) / 8] PROGMEM = { // gameOver.png
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x01, 0x00, 0x00,
  0xC0, 0x07, 0x00, 0x00, 0x02, 0x01, 0x00, 0x7C, 0x20, 0x08, 0xF8, 0x00,
  0x79, 0xFF, 0xFF, 0x83, 0x90, 0xF3, 0x07, 0xFF, 0x7D, 0x01, 0x00, 0x39,
  0xD1, 0x07, 0x70, 0x80, 0x0D, 0xBC, 0x7F, 0x7C, 0xD1, 0x76, 0xFB, 0xBC,
  0x6D, 0xBE, 0xFF, 0x6C, 0xD1, 0x76, 0xDB, 0xBE, 0x6D, 0xBF, 0xFF, 0x6D,
  0xD1, 0x76, 0xDB, 0xBE, 0x6D, 0xB7, 0xDD, 0x7D, 0xD1, 0x76, 0xFB, 0x8E,
  0x6D, 0xB7, 0xDD, 0x7D, 0xD1, 0xF6, 0xFB, 0xEE, 0x6D, 0xBF, 0xDD, 0x1D,
  0xD1, 0xF6, 0x39, 0x2E, 0x7D, 0xBE, 0xDD, 0xDD, 0xD1, 0xF7, 0xBA, 0x2E,
  0x79, 0xBC, 0xDD, 0x59, 0x90, 0x73, 0xB2, 0x2E, 0x02, 0x01, 0x00, 0x42,
  0x20, 0x04, 0x85, 0x20, 0xFC, 0xFF, 0xFF, 0x7F, 0xC0, 0xFF, 0xF8, 0x3F,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const uint8_t gameOverMaskBitmap[(64 * 16) / 8] PROGMEM = { // gameOverMask.png
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x01, 0x00, 0x00,
  0xC0, 0x07, 0x00, 0x00, 0xFE, 0x01, 0x00, 0x7C, 0xE0, 0x0F, 0xF8, 0x00,
  0xFF, 0xFF, 0xFF, 0xFF, 0xF0, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xF1, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF1, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xF1, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xF1, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF1, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xF1, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xF1, 0xFF, 0xFF, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xF1, 0xFF, 0xFF, 0x3F,
  0xFF, 0xFF, 0xFF, 0x7F, 0xF0, 0xFF, 0xFF, 0x3F, 0xFE, 0xFF, 0xFF, 0x7F,
  0xE0, 0xFF, 0xFD, 0x3F, 0xFC, 0xFF, 0xFF, 0x7F, 0xC0, 0xFF, 0xF8, 0x3F,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const uint8_t getReadyBitmap[(64 * 56) / 8] PROGMEM = { // getReady.png
  0xFC, 0x83, 0x1F, 0xFE, 0x00, 0x00, 0x3F, 0xFC, 0x02, 0xBE, 0x10, 0x02,
  0x3F, 0x00, 0x21, 0x84, 0xF9, 0xC2, 0x16, 0x7A, 0x41, 0x7F, 0xED, 0xB7,
  0xFD, 0x9C, 0x76, 0xFA, 0x9C, 0xC0, 0x0D, 0xB0, 0x0D, 0x3E, 0x46, 0xDA,
  0x3E, 0x1E, 0xEC, 0xB6, 0xED, 0xB6, 0x5F, 0xDA, 0x36, 0x9F, 0xEF, 0xB6,
  0xED, 0xB6, 0x5F, 0xDA, 0xB6, 0xDB, 0xEF, 0xB6, 0xED, 0x3E, 0x46, 0xFA,
  0xBE, 0xDB, 0xED, 0xB6, 0xED, 0xBE, 0x76, 0x7A, 0xBE, 0xDB, 0xED, 0xB6,
  0xFD, 0x8E, 0x46, 0xFA, 0x8E, 0xDF, 0xED, 0x87, 0xFD, 0xEE, 0x5E, 0xDA,
  0xAE, 0xDF, 0xCF, 0xB7, 0xF9, 0xAC, 0x5C, 0xDA, 0x2C, 0x9F, 0x0F, 0xB7,
  0x02, 0x21, 0x41, 0x02, 0x61, 0x40, 0xA0, 0x87, 0xFC, 0x3F, 0x7E, 0xFE,
  0xBF, 0xFF, 0xBF, 0xF3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x08,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x07, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x30, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08,
  0x21, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x51, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
  0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0xFC, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x41, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x21,
  0xFD, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x82, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x40, 0x1E, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xE0,
  0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x87, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40,
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x21, 0x02, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x10, 0x04, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x01, 0x20,
  0x02, 0x80, 0xFF, 0xFF, 0x01, 0x00, 0x02, 0x20, 0x02, 0x40, 0x00, 0x80,
  0xFD, 0xFF, 0x05, 0x20, 0x02, 0xA0, 0xFF, 0xBF, 0x8D, 0x88, 0x0B, 0xE0,
  0x03, 0xD0, 0x11, 0xB1, 0xDD, 0xAA, 0x17, 0x00, 0x00, 0xE8, 0x5B, 0xB5,
  0xDD, 0x88, 0x2F, 0x40, 0x00, 0xF4, 0x1B, 0xB1, 0xDD, 0xEA, 0x17, 0x40,
  0x00, 0xE8, 0x5B, 0xBD, 0xDD, 0xEA, 0x0B, 0x44, 0x04, 0xD0, 0x5B, 0xBD,
  0xFD, 0xFF, 0x05, 0x08, 0x02, 0xA0, 0xFF, 0xBF, 0x01, 0x00, 0x02, 0xC0,
  0x00, 0x40, 0x00, 0x80, 0xFF, 0xFF, 0x01, 0x20, 0x01, 0x80, 0xFF, 0xFF,
  0x00, 0x00, 0x00, 0x20, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x07, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x30, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28,
  0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x08, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
  0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x40, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0,
  0x0F, 0x00, 0x00, 0x00
};

const uint8_t getReadyMaskBitmap[(64 * 56) / 8] PROGMEM = { // getReadyMask.png
  0xFC, 0x83, 0x1F, 0xFE, 0x00, 0x00, 0x3F, 0xFC, 0xFE, 0xBF, 0x1F, 0xFE,
  0x3F, 0x00, 0x3F, 0xFC, 0xFF, 0xFF, 0x1F, 0xFE, 0x7F, 0x7F, 0xFF, 0xFF,
  0xFF, 0xFF, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0xFE,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0xFE,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0xFE,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFE, 0x3F, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x3F, 0x7E, 0xFE,
  0xBF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x0F,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x07, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xF0, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8,
  0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xFE, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE,
  0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0xFF, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xFF, 0xFF, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
  0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x40, 0xFE, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xE0,
  0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x87, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xC0,
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xE1, 0x03, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xF0, 0x07, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x01, 0xE0,
  0x03, 0x80, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0xE0, 0x03, 0xC0, 0xFF, 0xFF,
  0xFF, 0xFF, 0x07, 0xE0, 0x03, 0xE0, 0xFF, 0xFF, 0xFF, 0xFF, 0x0F, 0xE0,
  0x03, 0xF0, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0x00, 0x00, 0xF8, 0xFF, 0xFF,
  0xFF, 0xFF, 0x3F, 0x40, 0x00, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0x40,
  0x00, 0xF8, 0xFF, 0xFF, 0xFF, 0xFF, 0x0F, 0x44, 0x04, 0xF0, 0xFF, 0xFF,
  0xFF, 0xFF, 0x07, 0x08, 0x02, 0xE0, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0xC0,
  0x00, 0xC0, 0xFF, 0xFF, 0xFF, 0xFF, 0x01, 0xE0, 0x01, 0x80, 0xFF, 0xFF,
  0x00, 0x00, 0x00, 0xE0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0,
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x07, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xF0, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8,
  0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x1F, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xF8, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0,
  0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x1F, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xC0, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0,
  0x0F, 0x00, 0x00, 0x00
};

const uint8_t landBitmap[(128 * 8) / 8] PROGMEM = { // land.png
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
  0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0x78, 0x78, 0x78, 0x78,
  0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78,
  0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C,
  0x3C, 0x3C, 0x3C, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const uint8_t landMaskBitmap[(128 * 8) / 8] PROGMEM = { // landMask.png
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const uint8_t medalBitmap[4][(32 * 32) / 8] PROGMEM = {
  { // medalBronze.png
    0x00, 0xF0, 0x07, 0x00, 0x00, 0x0C, 0x18, 0x00, 0x00, 0x02, 0x20, 0x00,
    0x00, 0x01, 0x40, 0x00, 0x80, 0xE0, 0x87, 0x00, 0x40, 0x18, 0x09, 0x01,
    0x40, 0x84, 0x10, 0x01, 0x20, 0x82, 0x28, 0x02, 0x20, 0x81, 0x28, 0x02,
    0x20, 0x01, 0x21, 0x02, 0x20, 0x1F, 0x7E, 0x02, 0xA0, 0x20, 0x41, 0x02,
    0xA0, 0x90, 0x7E, 0x02, 0xE0, 0x08, 0x21, 0x03, 0x40, 0x0F, 0x1E, 0x01,
    0xC0, 0xF0, 0x81, 0x01, 0x80, 0x01, 0xC0, 0x00, 0x00, 0x03, 0x60, 0x00,
    0x00, 0x0E, 0x38, 0x00, 0x00, 0xFC, 0x1F, 0x00, 0x00, 0xF0, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x30, 0x77, 0xE9, 0x0E, 0x50, 0x55, 0x8B, 0x02,
    0x30, 0x53, 0x4D, 0x0E, 0x50, 0x55, 0x2D, 0x02, 0x30, 0x75, 0xE9, 0x0E,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
  },
  { // medalSilver.png
    0x00, 0xF0, 0x07, 0x00, 0x00, 0x0C, 0x18, 0x00, 0x00, 0x02, 0x20, 0x00,
    0x00, 0x01, 0x40, 0x00, 0x80, 0xE0, 0x87, 0x00, 0x40, 0x18, 0x09, 0x01,
    0x40, 0x84, 0x10, 0x01, 0x20, 0x82, 0x28, 0x02, 0x20, 0x81, 0x28, 0x02,
    0x20, 0x01, 0x21, 0x02, 0x20, 0x1F, 0x7E, 0x02, 0xA0, 0x20, 0x41, 0x02,
    0xA0, 0x90, 0x7E, 0x02, 0xE0, 0x08, 0x21, 0x03, 0x40, 0x0F, 0x1E, 0x01,
    0xC0, 0xF0, 0x81, 0x01, 0x80, 0x01, 0xC0, 0x00, 0x00, 0x03, 0x60, 0x00,
    0x00, 0x0E, 0x38, 0x00, 0x00, 0xFC, 0x1F, 0x00, 0x00, 0xF0, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xE0, 0x8A, 0xBA, 0x03, 0x20, 0x8A, 0x8A, 0x02,
    0xE0, 0x8A, 0xBA, 0x01, 0x80, 0x8A, 0x8A, 0x02, 0xE0, 0x3A, 0xB9, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
  },
  { // medalGold.png
    0x00, 0xF0, 0x07, 0x00, 0x00, 0x0C, 0x18, 0x00, 0x00, 0x02, 0x20, 0x00,
    0x00, 0x01, 0x40, 0x00, 0x80, 0xE0, 0x87, 0x00, 0x40, 0x18, 0x09, 0x01,
    0x40, 0x84, 0x10, 0x01, 0x20, 0x82, 0x28, 0x02, 0x20, 0x81, 0x28, 0x02,
    0x20, 0x01, 0x21, 0x02, 0x20, 0x1F, 0x7E, 0x02, 0xA0, 0x20, 0x41, 0x02,
    0xA0, 0x90, 0x7E, 0x02, 0xE0, 0x08, 0x21, 0x03, 0x40, 0x0F, 0x1E, 0x01,
    0xC0, 0xF0, 0x81, 0x01, 0x80, 0x01, 0xC0, 0x00, 0x00, 0x03, 0x60, 0x00,
    0x00, 0x0E, 0x38, 0x00, 0x00, 0xFC, 0x1F, 0x00, 0x00, 0xF0, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x31, 0x00, 0x00, 0x51, 0x51, 0x00,
    0x00, 0x55, 0x51, 0x00, 0x00, 0x55, 0x51, 0x00, 0x00, 0x77, 0x37, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
  },
  { // medalPlatinum.png
    0x00, 0xF0, 0x07, 0x00, 0x00, 0x0C, 0x18, 0x00, 0x00, 0x02, 0x20, 0x00,
    0x00, 0x01, 0x40, 0x00, 0x80, 0xE0, 0x87, 0x00, 0x40, 0x18, 0x09, 0x01,
    0x40, 0x84, 0x10, 0x01, 0x20, 0x82, 0x28, 0x02, 0x20, 0x81, 0x28, 0x02,
    0x20, 0x01, 0x21, 0x02, 0x20, 0x1F, 0x7E, 0x02, 0xA0, 0x20, 0x41, 0x02,
    0xA0, 0x90, 0x7E, 0x02, 0xE0, 0x08, 0x21, 0x03, 0x40, 0x0F, 0x1E, 0x01,
    0xC0, 0xF0, 0x81, 0x01, 0x80, 0x01, 0xC0, 0x00, 0x00, 0x03, 0x60, 0x00,
    0x00, 0x0E, 0x38, 0x00, 0x00, 0xFC, 0x1F, 0x00, 0x00, 0xF0, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x17, 0x77, 0xA5, 0xFA, 0x15, 0x25, 0xAD, 0xAA,
    0x17, 0x27, 0xB5, 0xAA, 0x11, 0x25, 0xB5, 0xAA, 0x71, 0x25, 0xA5, 0x8B,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
  }
};

const uint8_t newBitmap[(16 * 8) / 8] PROGMEM = { // new.png
  0xFF, 0xFF, 0x2D, 0xBA, 0xA9, 0xAB, 0x25, 0xAA, 0xAD, 0xAB, 0x2D, 0xD6, 0xFF, 0xFF, 0x00, 0x00
};

const uint8_t numberBitmap[10][(8 * 8) / 8] PROGMEM = {
  {0x3F, 0x21, 0x2D, 0x2D, 0x2D, 0x21, 0x3F, 0x00}, // number0.png
  {0x38, 0x28, 0x28, 0x28, 0x28, 0x28, 0x38, 0x00}, // number1.png
  {0x3F, 0x21, 0x2F, 0x21, 0x3D, 0x21, 0x3F, 0x00}, // number2.png
  {0x3F, 0x21, 0x2F, 0x21, 0x2F, 0x21, 0x3F, 0x00}, // number3.png
  {0x3F, 0x2D, 0x2D, 0x21, 0x2F, 0x28, 0x38, 0x00}, // number4.png
  {0x3F, 0x21, 0x3D, 0x21, 0x2F, 0x21, 0x3F, 0x00}, // number5.png
  {0x3F, 0x21, 0x3D, 0x21, 0x2D, 0x21, 0x3F, 0x00}, // number6.png
  {0x3F, 0x21, 0x2F, 0x28, 0x28, 0x28, 0x38, 0x00}, // number7.png
  {0x3F, 0x21, 0x2D, 0x21, 0x2D, 0x21, 0x3F, 0x00}, // number8.png
  {0x3F, 0x21, 0x2D, 0x21, 0x2F, 0x21, 0x3F, 0x00}  // number9.png
};

const uint8_t numberMaskBitmap[10][(8 * 8) / 8] PROGMEM = {
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}, // numberMask0.png
  {0x38, 0x38, 0x38, 0x38, 0x38, 0x38, 0x38, 0x00}, // numberMask1.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}, // numberMask2.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}, // numberMask3.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x38, 0x38, 0x00}, // numberMask4.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}, // numberMask5.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}, // numberMask6.png
  {0x3F, 0x3F, 0x3F, 0x38, 0x38, 0x38, 0x38, 0x00}, // numberMask7.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}, // numberMask8.png
  {0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x00}  // numberMask9.png
};

const uint8_t numberScoreBitmap[10][(8 * 16) / 8] PROGMEM = {
  {0x7F, 0xC1, 0xC1, 0xC9, 0xC9, 0xC9, 0xC9, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore0.png
  {0x7C, 0xC4, 0xC4, 0xCC, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore1.png
  {0x7F, 0xC1, 0xC1, 0xCF, 0xC1, 0xC1, 0xF9, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore2.png
  {0x7F, 0xC1, 0xC1, 0xCF, 0xC1, 0xC1, 0xCF, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore3.png
  {0x7F, 0xC9, 0xC9, 0xC9, 0xC9, 0xC1, 0xC1, 0xCF, 0xCE, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore4.png
  {0x7F, 0xC1, 0xC1, 0xF9, 0xC1, 0xC1, 0xCF, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore5.png
  {0x7F, 0xC1, 0xC1, 0xF9, 0xC1, 0xC1, 0xC9, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore6.png
  {0x7F, 0xC1, 0xC1, 0xC9, 0xC9, 0xCF, 0xCE, 0xC8, 0xC8, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore7.png
  {0x7F, 0xC1, 0xC1, 0xC9, 0xC1, 0xC1, 0xC9, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScore8.png
  {0x7F, 0xC1, 0xC1, 0xC9, 0xC1, 0xC1, 0xCF, 0xC1, 0xC1, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}  // numberScore9.png
};

const uint8_t numberScoreMaskBitmap[10][(8 * 16) / 8] PROGMEM = {
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask0.png
  {0x7C, 0xFC, 0xFC, 0xFC, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask1.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask2.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask3.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask4.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask5.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask6.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xF8, 0xF8, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask7.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}, // numberScoreMask8.png
  {0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00}  // numberScoreMask9.png
};

const uint8_t pipeDownBitmap[(16 * 32) / 8] PROGMEM = { // pipeDown.png
  0xFF, 0x3F, 0x43, 0x3D, 0x81, 0x3A, 0x43, 0x3D, 0xFF, 0x3F, 0x86, 0x1E,
  0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E,
  0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E,
  0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E,
  0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E,
  0x02, 0x1D, 0x86, 0x1E
};

const uint8_t pipeDownMaskBitmap[(16 * 32) / 8] PROGMEM = { // pipeDownMask.png
  0xFF, 0x3F, 0xFF, 0x3F, 0xFF, 0x3F, 0xFF, 0x3F, 0xFF, 0x3F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F
};

const uint8_t pipeUpBitmap[(16 * 32) / 8] PROGMEM = { // pipeUp.png
  0x86, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D,
  0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D,
  0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D,
  0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D, 0x06, 0x1E, 0x02, 0x1D,
  0x06, 0x1E, 0x02, 0x1D, 0x86, 0x1E, 0xFF, 0x3F, 0x43, 0x3D, 0x81, 0x3A,
  0x43, 0x3D, 0xFF, 0x3F
};

const uint8_t pipeUpMaskBitmap[(16 * 32) / 8] PROGMEM = { // pipeUpMask.png
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F,
  0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x1F, 0xFF, 0x3F, 0xFF, 0x3F, 0xFF, 0x3F,
  0xFF, 0x3F, 0xFF, 0x3F
};

const uint8_t scorePanelBitmap[(80 * 40) / 8] PROGMEM = { // scorePanel.png
  0xF8, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0x04, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x02, 0xD1, 0x1D, 0x13,
  0x00, 0x00, 0x70, 0x66, 0xCE, 0x09, 0x01, 0x5B, 0xA4, 0x14, 0x00, 0x00,
  0x08, 0x91, 0x52, 0x10, 0x01, 0xD5, 0xA5, 0x14, 0x00, 0x00, 0x30, 0x91,
  0xD2, 0x11, 0x01, 0x51, 0xA4, 0x17, 0x00, 0x00, 0x40, 0x91, 0x4E, 0x10,
  0x01, 0xD1, 0x9D, 0x74, 0x00, 0x00, 0x38, 0x66, 0xD2, 0x11, 0x01, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00, 0x15, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x10, 0x01, 0x10, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
  0x01, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x02, 0x00, 0x08,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x10, 0x01, 0x01, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
  0x01, 0x01, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x01, 0x00, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0xE7, 0xDC, 0x11, 0x01, 0x02, 0x00, 0x08, 0x00, 0x00, 0x00, 0x29,
  0x82, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE7, 0x8C, 0x10,
  0x01, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x29, 0x90, 0x10, 0x01, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0xE7, 0x8E, 0x10, 0x01, 0x10, 0x00, 0x01,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x10, 0x01, 0x00, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x10, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x18, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C,
  0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xF8, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

const uint8_t scorePanelMaskBitmap[(80 * 40) / 8] PROGMEM = { // scorePanelMask.png
  0xF8, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0xFC, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xFE, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0x1F, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x0F,
  0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xF8, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

const uint8_t titleBitmap[(72 * 24) / 8] PROGMEM = { // title.png
  0xFC, 0x07, 0x00, 0x00, 0x80, 0x1F, 0x00, 0xF0, 0x00, 0x42, 0x04, 0x00,
  0x00, 0x80, 0x20, 0x00, 0x90, 0x00, 0x41, 0x04, 0x00, 0x80, 0xFF, 0xC0,
  0x07, 0x90, 0x00, 0x71, 0xF4, 0x7F, 0xBF, 0x88, 0x48, 0xF4, 0x9D, 0x00,
  0x41, 0x0C, 0x82, 0xC1, 0x88, 0x48, 0x0C, 0x83, 0x00, 0x41, 0x04, 0x02,
  0x81, 0x88, 0xC0, 0x07, 0x81, 0x00, 0x41, 0x44, 0x22, 0x91, 0x88, 0x40,
  0xC4, 0x91, 0x00, 0x71, 0x44, 0x22, 0x91, 0x80, 0x48, 0xE4, 0x91, 0x00,
  0x71, 0x44, 0x22, 0x91, 0x81, 0x48, 0x24, 0x91, 0x00, 0x51, 0x04, 0x02,
  0x81, 0x83, 0x40, 0x24, 0x81, 0x00, 0x51, 0x0C, 0x82, 0xC1, 0x8E, 0x60,
  0x24, 0x83, 0x00, 0xDF, 0xFF, 0xE3, 0x71, 0x8E, 0xFF, 0x3F, 0xFE, 0x00,
  0xDF, 0xF7, 0x63, 0x31, 0x82, 0xDF, 0x3F, 0xFC, 0x00, 0x00, 0x00, 0x22,
  0x11, 0xC2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x1F, 0x7E, 0x2E,
  0x00, 0x82, 0x00, 0x00, 0x00, 0x3E, 0x1F, 0x3E, 0x02, 0x00, 0x82, 0x01,
  0x00, 0x00, 0x00, 0x00, 0x00, 0xAE, 0xAD, 0x9A, 0xDC, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xA8, 0xAA, 0xA2, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAE,
  0xEA, 0xBA, 0x5D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const uint8_t titleMaskBitmap[(72 * 24) / 8] PROGMEM = { // titleMask.png
  0xFC, 0x07, 0x00, 0x00, 0x80, 0x1F, 0x00, 0xF0, 0x00, 0xFE, 0x07, 0x00,
  0x00, 0x80, 0x3F, 0x00, 0xF0, 0x00, 0xFF, 0x07, 0x00, 0x80, 0xFF, 0xFF,
  0x07, 0xF0, 0x00, 0xFF, 0xF7, 0x7F, 0xBF, 0xFF, 0xFF, 0xF7, 0xFD, 0x00,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x3F, 0xFF, 0x00, 0xDF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0x3F, 0xFF, 0x00, 0xDF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFF,
  0x3F, 0xFF, 0x00, 0xDF, 0xFF, 0xFF, 0x7F, 0xFE, 0xFF, 0x3F, 0xFE, 0x00,
  0xDF, 0xF7, 0x7F, 0x3F, 0xFE, 0xDF, 0x3F, 0xFC, 0x00, 0x00, 0x00, 0x3E,
  0x1F, 0xFE, 0x7F, 0x00, 0xC7, 0x01, 0x00, 0x00, 0x3E, 0x1F, 0x7E, 0x7F,
  0x00, 0xC7, 0x03, 0x00, 0x00, 0x3E, 0x1F, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF,
  0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
  0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

class FlappyBird : public Game {
  private:
    typedef enum {
      SOUND_NONE,
      SOUND_DIE,
      SOUND_SCORE,
      SOUND_SCORE_NEXT,
      SOUND_VOLUME
    } SoundType;

    typedef enum {
      GAME_MODE_TITLE,
      GAME_MODE_GET_READY,
      GAME_MODE_PLAY,
      GAME_MODE_GAME_OVER
    } GameMode;

    typedef enum {
      MEDAL_BRONZE,
      MEDAL_SILVER,
      MEDAL_GOLD,
      MEDAL_PLATINUM
    } MedalType;

    // game
    int gameMode;
    float gameOverVelocity;
    Point gameOverPosition;
    bool isGameOver;
    bool isCheckHighScore;
    float titleTime;
    float getReadyTime;
    float gameOverTime;
    bool isAutoPlay;

    // bird
    Size birdSize;
    float birdAnimationSpeed;
    float birdFrame;
    float birdDegrees;
    int birdFirstFrame;
    int birdFrameDirection;
    bool isDropping;
    float heightRatio;
    float gravity;
    float velocity;
    float initialVelocity;
    Point birdPosition;
    float dropPosition;
    bool isHit;
    Point birdCollisionOffset;

    // land
    Size landSize;
    float landSpeed;
    Point landOffset;
    float landPosition;

    // score
    bool isNewHighScore;
    Point scorePosition[3];
    const uint8_t* scoreDigitImage[3];
    const uint8_t* scoreDigitMaskImage[3];

    // score panel
    float maxScorePanelOffset;
    float scorePanelOffset;
    float scorePanelScore;
    float scorePanelHighScore;
    const uint8_t* scorePanelHighScoreDigitImage[3];
    const uint8_t* scorePanelScoreDigitImage[3];
    const uint8_t* scorePanelMedalImage;

    // pipe
    Size pipeSize;
    int pipeMinLength;
    int heightBetweenPipes;
    static const int numberOfPipes = 3;
    int pipeRandomFrom;
    int pipeRandomTo;
    Point pipePosition[numberOfPipes];
    bool isPipeVisibled[numberOfPipes];
    bool isPipeEnabled[numberOfPipes];
    float pipeRandomFirstTime;
    float pipeRandomNextTime;
    float pipeRandomTime;

    void addScore(int value);
    void changeGameMode(int mode);
    void checkHighScore();
    void initGame();
    bool isHitPipe();
    void jump();
    void playSound(int index);
    void pressButton();
    void renderHighScore();
    void resetBird();
    void resetGame();
    void setScoreImages();
    void setScorePanelImages(const uint8_t* digitImage[3], int value);
    void updateBirdAnimation(bool rotate);

  public:
    FlappyBird();
    bool isBackToMenuEnabled();
    void update();
    void render();
};
}

#endif
